Minitest - invalid return code when using MiniTest::Unit.after_tests
Status: Rejected   

Priority: Normal   

Assignee: zenspider (Ryan Davis)   

Target version:    

ruby -v: ruby 1.9.2p136 (2010-12-25 revision

30365) [i686-linux]

Backport:  

Description

If test fails and MiniTest::Unit.after_tests is used then the program returned code is 0 but it should not be.

Here is my current workaround:

MiniTest::Unit.after_tests do

status = ($! && $!.respond_to?(:status) && $!.status) || 0

do something...

exit(status)

end

History

#1 - 05/09/2011 08:32 PM - sorah (Sorah Fukumori)

- Category set to lib

- Assignee set to zenspider (Ryan Davis)

minitest has an upstream.

Could report same issue to at the following url?

http://rubyforge.org/tracker/?atid=4097&group_id=1040&func=browse

#2 - 06/11/2011 04:07 PM - ko1 (Koichi Sasada)

- Status changed from Open to Feedback

#3 - 06/22/2011 07:54 AM - zenspider (Ryan Davis)

I can't replicate with ruby 1.8 or 1.9.2:

require 'rubygems'

gem 'minitest' # ensure latest gem in 1.9

require 'minitest/autorun'

class TestX < MiniTest::Unit::TestCase

  def test_x

    flunk

  end

end

MiniTest::Unit.after_tests do

  p :woot

end

 exits 1

#4 - 06/23/2011 12:41 PM - zenspider (Ryan Davis)

Just in case a repro comes up, the above code doesn't cover all cases correctly. I'm currently going with:

status = $!.respond_to?(:status) ? $!.status : ($! ? 1 : 0)
#5 - 07/16/2011 07:25 AM - zenspider (Ryan Davis)

- Status changed from Feedback to Rejected

No reply. Closing.
